package com.heroku.api.request.key;

import com.heroku.api.Heroku;
import com.heroku.api.Key;
import com.heroku.api.exception.RequestFailedException;
import com.heroku.api.http.Http;
import com.heroku.api.request.Request;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;

import static com.heroku.api.http.HttpUtil.noBody;
import static com.heroku.api.parser.Json.parse;

/**
 * TODO: Javadoc
 *
 * @author Naaman Newbold
 */
public class KeyList implements Request<List<Key>> {

    @Override
    public Http.Method getHttpMethod() {
        return Http.Method.GET;
    }

    @Override
    public String getEndpoint() {
        return Heroku.Resource.Keys.value;
    }

    @Override
    public boolean hasBody() {
        return false;
    }

    @Override
    public String getBody() {
        throw noBody();
    }

    @Override
    public Http.Accept getResponseType() {
        return Http.Accept.JSON;
    }

    @Override
    public Map<String, String> getHeaders() {
        return Collections.emptyMap();
    }

    @Override
    public List<Key> getResponse(byte[] bytes, int status) {
        if (status == Http.Status.OK.statusCode) {
            if (new String(bytes).contains("nil-classes")) {
                return new ArrayList<Key>();
            }
            return parse(bytes, getClass());
        } else {
            throw new RequestFailedException("Unable to list keys.", status, bytes);
        }
    }

}
